package com.simpleinventory.app.fragment;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.text.Html;
import android.text.method.ScrollingMovementMethod;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.TextView;
import com.simpleinventory.app.R;
import com.simpleinventory.app.helper.PrintTask;
import android.widget.Toast;

import java.util.concurrent.ExecutionException;

public class GetInfo extends Fragment implements OnClickListener
{
    private Fragment contentFragment;
    TextView tv = null;

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
        final View rootView = inflater.inflate(R.layout.get_info, container, false);

        rootView.findViewById(R.id.stockInBtn).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v)
            {

                SendSBPL stockInFragment  = new SendSBPL();
                switchContent(stockInFragment, "send_SBPL");
            }
        });


        rootView.findViewById(R.id.stockOutBtn).setOnClickListener(
                new OnClickListener() {
                    @Override
                    public void onClick(View v)
                    {
                        GetInfo stockOutFragment  = new GetInfo();
                        switchContent(stockOutFragment, "get_info");
                    }
                });

        rootView.findViewById(R.id.InventoryBtn).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v)
            {
                SetInfo stockInv  = new SetInfo();
                switchContent(stockInv, "set_info");
            }
        });

        rootView.findViewById(R.id.buttonAcqire).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v)
            {
                PrintTask.variableMap = null; //must be a null as the null is for port acqiring,Damo
                PrintTask.isPortSet=false;
                new PrintTask(getActivity()).execute(""); //very important point, we calling the smartPri class here, Damo
                AcquireData();
            }
        });

        return rootView;
    }

    private void AcquireData()
    {
        if(PrintTask.resultFinal!=null) //... and based on the reply we get the results
        {
            tv = (TextView)getView().findViewById(R.id.textViewinp);
            tv.setMovementMethod(new ScrollingMovementMethod());

            tv.setText("");

            for(int i=3; i<PrintTask.resultFinal.size(); i++)
                tv.append(Html.fromHtml(PrintTask.resultFinal.keySet().toArray()[i].toString().replace(".@","").toUpperCase()+":  <b>"+PrintTask.resultFinal.values().toArray()[i].toString()+"</b>"+"<br />"));
        }
       else
       {
            Toast toast = Toast.makeText(getActivity(), "No Data Acquired", Toast.LENGTH_SHORT);
            toast.show();
       }
    }

    public void switchContent(Fragment fragment, String tag)
    {
        FragmentManager fragmentManager = getActivity().getSupportFragmentManager();;
        while (fragmentManager.popBackStackImmediate());

        if(fragment != null)
        {
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.replace(R.id.content_frame, fragment, tag);
            transaction.addToBackStack(tag);
            transaction.commit();
            contentFragment = fragment;
        }
    }

    @Override
    public void onResume()
    {
        PrintTask.variableMap = null;//must be a null as the null is for port acqiring,Damo
        PrintTask.isPortSet=false;
        new PrintTask(getActivity()).execute(""); //very important point, we canll the smartPri class here, Damo

        AcquireData();
        super.onResume();
    }

    @Override
    public void onSaveInstanceState(Bundle outState)
    {

    }

    @Override
    public void onClick(View view)
    {

    }
}
